﻿using CarRepairShopListImplement.Models;

namespace CarRepairShopListImplement
{
    public class DataListSingleton
    {
        private static DataListSingleton? _instance;
        public List<Component> Components { get; set; }
        public List<Repair> Repairs { get; set; } 
        public List<Order> Orders { get; set; }
        public List<Shop> Shops { get; set; }

        private DataListSingleton()
        {
            Components = new List<Component>();
            Repairs = new List<Repair>();
            Orders = new List<Order>();
            Shops = new List<Shop>();
        }

        public static DataListSingleton GetInstance()
        {
            if(_instance == null)
            {
                _instance = new DataListSingleton();
            }
            return _instance;
        }
    }
}
