﻿using CarRepairShopContracts.BindingModels;
using CarRepairShopContracts.ViewModels;
using CarRepairShopDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CarRepairShopListImplement.Models
{
    public class Shop : IShopModel
    {
        public int Id { get; private set; }
        public string ShopName { get; private set; } = string.Empty;
        public string ShopAddress { get; private set; } = string.Empty;
        public DateTime DateOpen { get; private set; } = DateTime.Now;
        public int MaxCountRepairs { get; set; }
        public Dictionary<int, (IRepairModel, int)> ShopRepairs { get; private set; } = new Dictionary<int, (IRepairModel, int)>();

        public static Shop? Create(ShopBindingModel? model)
        {
            if (model == null) return null;
            return new Shop()
            {
                Id = model.Id,
                ShopName = model.ShopName,
                ShopAddress = model.ShopAddress,
                DateOpen = model.DateOpen,
                ShopRepairs = model.ShopRepairs
            };
        }

        public void Update(ShopBindingModel? model)
        {
            if(model == null) return;
            ShopName = model.ShopName;
            ShopAddress = model.ShopAddress;
            DateOpen = model.DateOpen;
        }

        public ShopViewModel GetViewModel => new()
        {
            Id = Id,
            ShopName = ShopName,
            ShopAddress = ShopAddress,
            DateOpen = DateOpen,
            ShopRepairs = ShopRepairs
        };

    }
}
